# this is only turned on during transitional periods
%{?python3_next_pkgversion: %global with_python3_next 1}

%global _configure ../configure


Name:           xapps
Version:        1.0.4
Release:        13%{?dist}
Summary:        Common files for XApp desktop apps

License:        LGPLv2+
URL:            https://github.com/linuxmint/%{name}
Source0:        %{url}/archive/%{version}.tar.gz#/%{name}-%{version}.tar.gz
Source1:        %{url}/../flags/archive/1.0.1.tar.gz#/flags-1.0.1.tar.gz

BuildRequires:  glib2-devel
BuildRequires:  gnome-common
BuildRequires:  gobject-introspection-devel
BuildRequires:  gtk-doc
BuildRequires:  gtk3-devel
BuildRequires:  intltool
BuildRequires:  libX11-devel
BuildRequires:  libgnomekbd-devel
BuildRequires:  pygobject3-devel

Requires:       fpaste
Requires:       inxi
%if 0%{?fedora} || 0%{?rhel} >= 8
Requires:       python3-xapps-overrides%{?_isa} = %{version}-%{release}
%else
Requires:       python2-xapps-overrides%{?_isa} = %{version}-%{release}
%endif
Requires:       xdg-utils

%description
This package includes files that are shared between several XApp
apps (i18n files and configuration schemas).


%package        devel
Summary:        Development files for %{name}
Requires:       %{name}%{?_isa} = %{version}-%{release}

%description    devel
Development libraries and header files for
developing XApp apps.

%package     -n python2-xapps-overrides
Summary:        Python2 files for %{name}

%if 0%{?fedora} >=27 || 0%{?rhel} >= 8
Requires:       python2-gobject-base%{?_isa}
%else
Requires:       python-gobject-base%{?_isa}
%endif
Requires:       %{name}%{?_isa} = %{version}-%{release}

BuildRequires:  python2-devel

%description -n python2-xapps-overrides
Python2 files for XApp apps.


%package     -n python%{python3_pkgversion}-xapps-overrides
Summary:        Python%{python3_version} files for %{name}

Requires:       python%{python3_pkgversion}-gobject-base%{?_isa}
Requires:       %{name}%{?_isa} = %{version}-%{release}

BuildRequires:  python%{python3_pkgversion}-devel
BuildRequires:  python%{python3_pkgversion}-gobject

%if ("python%{python3_pkgversion}-xapps-overrides" != "python3-xapps-overrides") && !0%{?with_python3_next}
Provides:       python3-xapps-overrides = %{version}-%{release}
Provides:       python3-xapps-overrides%{?_isa} = %{version}-%{release}
%endif

%description -n python%{python3_pkgversion}-xapps-overrides
Python%{python3_version} files for XApp apps.


%if 0%{?with_python3_next}
%package     -n python%{python3_next_pkgversion}-xapps-overrides
Summary:        Python%{python3_next_version} files for %{name}

Requires:       python%{python3_next_pkgversion}-gobject-base%{?_isa}
Requires:       %{name}%{?_isa} = %{version}-%{release}

BuildRequires:  python%{python3_next_pkgversion}-devel
BuildRequires:  python%{python3_next_pkgversion}-gobject

%if ("python%{python3_next_pkgversion}-xapps-overrides" != "python3-xapps-overrides") && 0%{?with_python3_next}
Provides:       python3-xapps-overrides = %{version}-%{release}
Provides:       python3-xapps-overrides%{?_isa} = %{version}-%{release}
%endif

%description -n python%{python3_next_pkgversion}-xapps-overrides
Python%{python3_next_version} files for XApp apps.
%endif


%prep
%autosetup -p1
tar -xf %{SOURCE1} -C files/usr/share --strip 3
rm files/usr/share/format

%if (0%{?rhel} && 0%{?rhel} <= 7)
for f in $(%{__grep} -Rl '#!.*python3') ; do
  %{__sed} -e 's~#!.*python3~#!/usr/bin/python2~g' < ${f} > ${f}.new
  /bin/touch -r ${f}.new ${f}
  mode="$(%{_bindir}/stat -c '%a' ${f})"
  %{__mv} -f ${f}.new ${f}
  %{__chmod} -c ${mode} ${f}
done
%endif # (0%%{?rhel} && 0%%{?rhel} >= 7)

NOCONFIGURE=1 ./autogen.sh


%build
mkdir -p build-py2 build-py3 build-py3-next
cp -a files/ build-py2/
cp -a files/ build-py3/
cp -a files/ build-py3-next/

pushd build-py2
export PYTHON=%{__python2}
%configure
sed -i -e 's! -shared ! -Wl,--as-needed\0!g' libtool
%make_build V=1
popd

pushd build-py3
export PYTHON=%{__python3}
%configure
sed -i -e 's! -shared ! -Wl,--as-needed\0!g' libtool
%make_build V=1
popd

%if 0%{?with_python3_next}
pushd build-py3-next
export PYTHON=%{__python3_next}
%configure
sed -i -e 's! -shared ! -Wl,--as-needed\0!g' libtool
%make_build V=1
popd
%endif


%install
%make_install -C build-py2
%make_install -C build-py3
%if 0%{?with_python3_next}
%make_install -C build-py3-next
%endif

find $RPM_BUILD_ROOT -name '*.la' -exec rm -f {} ';'


%post
/sbin/ldconfig
/bin/touch --no-create %{_datadir}/icons/hicolor &>/dev/null || :

%postun
/sbin/ldconfig
if [ $1 -eq 0 ] ; then
    /bin/touch --no-create %{_datadir}/icons/hicolor &>/dev/null
    /usr/bin/gtk-update-icon-cache %{_datadir}/icons/hicolor &>/dev/null || :
fi

%posttrans
/usr/bin/gtk-update-icon-cache %{_datadir}/icons/hicolor &>/dev/null || :


%files
%license COPYING
%doc README.md
%{_bindir}/pastebin
%{_bindir}/upload-system-info
%{_bindir}/xfce4-set-wallpaper
%{_libdir}/libxapp.so.*
%{_libdir}/girepository-1.0/XApp-1.0.typelib
%{_datadir}/iso-flag-png/
%{_datadir}/glib-2.0/schemas/org.x.apps.*.xml
%{_datadir}/icons/hicolor/scalable/actions/*.svg


%files devel
%{_includedir}/*
%{_libdir}/libxapp.so
%{_libdir}/pkgconfig/xapp.pc
%{_datadir}/gir-1.0/XApp-1.0.gir
%{_datadir}/glade/catalogs/xapp-glade-catalog.xml
%{_datadir}/vala/vapi/xapp.vapi


%files -n python2-xapps-overrides
%{python2_sitearch}/gi/overrides/XApp.py*


%files -n python%{python3_pkgversion}-xapps-overrides
%{python3_sitearch}/gi/overrides/XApp.py
%{python3_sitearch}/gi/overrides/__pycache__/XApp.cpython-%{python3_version_nodots}*.py*


%if 0%{?with_python3_next}
%files -n python%{python3_next_pkgversion}-xapps-overrides
%{python3_next_sitearch}/gi/overrides/XApp.py
%{python3_next_sitearch}/gi/overrides/__pycache__/XApp.cpython-%{python3_next_version_nodots}*.py*
%endif


%changelog
* Thu Nov 29 2018 Pat Riehecky <riehecky@fnal.gov> - 1.0.4-13
- Return to EPEL7

* Mon Nov 20 2017 Leigh Scott <leigh123linux@googlemail.com> - 1.0.4-12
- Fix Requires for F26

* Thu Nov 16 2017 Björn Esser <besser82@fedoraproject.org> - 1.0.4-11
- Fix Requires for EPEL7

* Thu Nov 16 2017 Björn Esser <besser82@fedoraproject.org> - 1.0.4-10
- Fix globbing of __pycache__

* Thu Nov 16 2017 Björn Esser <besser82@fedoraproject.org> - 1.0.4-9
- Fix Python3 macro again

* Thu Nov 16 2017 Björn Esser <besser82@fedoraproject.org> - 1.0.4-8
- Fix archful Requires

* Thu Nov 16 2017 Björn Esser <besser82@fedoraproject.org> - 1.0.4-7
- Fix Python3 macro

* Thu Nov 16 2017 Björn Esser <besser82@fedoraproject.org> - 1.0.4-6
- Fix build

* Thu Nov 16 2017 Björn Esser <besser82@fedoraproject.org> - 1.0.4-5
- Adaptions for EPEL7

* Mon Nov 13 2017 Troy Curtis, Jr <troycurtisjr@gmail.com> - 1.0.4-4
- Have python2-xapps-overrides require xapps instead of the other way around.
- Use python macros

* Sat Nov 11 2017 Leigh Scott <leigh123linux@googlemail.com> - 1.0.4-3
- Add requires python2-gobject-base

* Thu Oct 26 2017 Leigh Scott <leigh123linux@googlemail.com> - 1.0.4-2
- build python XApp overrides

* Tue Oct 24 2017 Leigh Scott <leigh123linux@googlemail.com> - 1.0.4-1
- update to 1.0.4 release

* Thu Aug 31 2017 Björn Esser <besser82@fedoraproject.org> - 1.0.3-6
- Preserve mode of files when changing hashbang

* Tue Aug 29 2017 Björn Esser <besser82@fedoraproject.org> - 1.0.3-5
- Use Python2 on epel

* Mon Aug 28 2017 Leigh Scott <leigh123linux@googlemail.com> - 1.0.3-4
- Fix requires for epel

* Thu Aug 03 2017 Fedora Release Engineering <releng@fedoraproject.org> - 1.0.3-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_27_Binutils_Mass_Rebuild

* Thu Jul 27 2017 Fedora Release Engineering <releng@fedoraproject.org> - 1.0.3-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_27_Mass_Rebuild

* Wed May 03 2017 Leigh Scott <leigh123linux@googlemail.com> - 1.0.3-1
- update to 1.0.3 release
- add build requires gtk-doc

* Thu Feb 23 2017 Leigh Scott <leigh123linux@googlemail.com> - 1.0.2-5
- Add python3-gobject-base instead of python-gobject-base

* Thu Feb 23 2017 Leigh Scott <leigh123linux@googlemail.com> - 1.0.2-4
- Add some upstream fixes

* Sat Feb 11 2017 Fedora Release Engineering <releng@fedoraproject.org> - 1.0.2-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_26_Mass_Rebuild

* Mon Dec 19 2016 Miro Hrončok <mhroncok@redhat.com> - 1.0.2-2
- Rebuild for Python 3.6

* Mon Nov 07 2016 Leigh Scott <leigh123linux@googlemail.com> - 1.0.2-1
- update to 1.0.2 release

* Sat Nov 05 2016 Leigh Scott <leigh123linux@googlemail.com> - 1.0.0-0.3.gita8d5277
- update to latest git

* Tue Oct 11 2016 Leigh Scott <leigh123linux@googlemail.com> - 1.0.0-0.2.git0f28d18
- fix review issues

* Sat Oct 08 2016 Leigh Scott <leigh123linux@googlemail.com> - 1.0.0-0.1.git7e7567a
- first build
